GNU bug report logs - #70549
[PATCH] doc: Make changes to the handling of branches.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Christopher Baines <mail@HIDDEN>; Keywords: patch; dated Wed, 24 Apr 2024 13:10:03 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 8 May 2024 11:30:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 08 07:30:32 2024
Received: from localhost ([127.0.0.1]:48348 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s4fVI-0006q1-1j
	for submit <at> debbugs.gnu.org; Wed, 08 May 2024 07:30:32 -0400
Received: from mira.cbaines.net ([212.71.252.8]:43422)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1s4fVD-0006bV-9f
 for 70549 <at> debbugs.gnu.org; Wed, 08 May 2024 07:30:31 -0400
Received: from localhost (unknown [212.132.255.10])
 by mira.cbaines.net (Postfix) with ESMTPSA id 91D8327BBE2
 for <70549 <at> debbugs.gnu.org>; Wed,  8 May 2024 12:30:00 +0100 (BST)
Received: from localhost (localhost [local])
 by localhost (OpenSMTPD) with ESMTPA id a1c11969
 for <70549 <at> debbugs.gnu.org>; Wed, 8 May 2024 11:30:00 +0000 (UTC)
From: Christopher Baines <mail@HIDDEN>
To: 70549 <at> debbugs.gnu.org
Subject: [PATCH v2] doc: Make changes to the handling of branches.
Date: Wed,  8 May 2024 12:29:59 +0100
Message-ID: <112222932424e4b346500995cbfd5866ef30b732.1715167799.git.mail@HIDDEN>
X-Mailer: git-send-email 2.41.0
MIME-Version: 1.0
X-Debbugs-Cc: Florian Pelz <pelzflorian@HIDDEN>, Ludovic Court├Ęs <ludo@HIDDEN>
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 70549
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Require that you create a "Request to merge" issue when you create a branch,
rather than when you wish to merge it.  This should help avoid this step being
missed.

Also, add information on how to manage these branches:

 1. Suggest creating the branch from patches, rather than having a stateful
 branch, since this should help to reduce complexity and avoid merges.

 2. Require that branches don't have unnecessary changes, since this increases
 the risks of conflicts with other branches.

 3. Suggest that the branch not be stateful, and it's just a combination of
 patches.

 4. Suggest avoiding merges since these create a more complicated Git history.

 5. Suggest that the branch be up to date before merging, as this helps avoid
 the combination of master plus the branch differing significantly from the
 branch alone.

Finally, require that the branch be deleted once they're merged.  This
prepares for the branch being created again.

* doc/contributing.texi (Managing Patches and Branches): Make changes to the
handling of branches.

Change-Id: Ib9419c6df94f485475bd6f147e82ea254e76cec2
---
 doc/contributing.texi | 68 ++++++++++++++++++++++++++++++++-----------
 1 file changed, 51 insertions(+), 17 deletions(-)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index 66f4e86d0a..ecff6300bf 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -2298,9 +2298,9 @@ Managing Patches and Branches
 
 @cindex feature branches, coordination
 To help coordinate the merging of branches, you must create a new
-guix-patches issue each time you wish to merge a branch (@pxref{The
-Issue Tracker}).  The title of the issue requesting to merge a branch
-should have the following format:
+guix-patches issue each time you create a branch (@pxref{The Issue
+Tracker}).  The title of the issue requesting to merge a branch should
+have the following format:
 
 @cindex merge requests, template
 @example
@@ -2308,20 +2308,51 @@ Managing Patches and Branches
 @end example
 
 The @url{https://qa.guix.gnu.org/, QA infrastructure} recognizes such
-issues and lists the merge requests on its main page.  Normally branches
-will be merged in a ``first come, first merged'' manner, tracked through
-the guix-patches issues.
-
-If you agree on a different order with those involved, you can track
-this by updating which issues block@footnote{You can mark an issue as
-blocked by another by emailing @email{control@@debbugs.gnu.org} with the
-following line in the body of the email: @code{block XXXXX by YYYYY}.
-Where @code{XXXXX} is the number for the blocked issue, and @code{YYYYY}
-is the number for the issue blocking it.} which other issues.
-Therefore, to know which branch is at the front of the queue, look for
-the oldest issue, or the issue that isn't @dfn{blocked} by any other
-branch merges.  An ordered list of branches with the open issues is
-available at @url{https://qa.guix.gnu.org}.
+issues and lists the merge requests on its main page.  The following
+points apply to managing these branches:
+
+@enumerate
+@item
+The commits on the branch should be a combination of the patches
+relevant to the branch.  Patches not related to the topic of the branch
+should go elsewhere.
+
+@item
+Any changes that can be made on the master branch, should be made on the
+master branch.  If a commit can be split to apply part of the changes on
+master, this is good to do.
+
+@item
+It should be possible to re-create the branch by starting from master
+and applying the relevant patches.
+
+@item
+Avoid merging master in to the branch.  Prefer rebasing or re-creating
+the branch on top of an updated master revision.
+
+@item
+Minimise the changes on master that are missing on the branch prior to
+merging the branch in to master.  This means that the state of the
+branch better reflects the state of master should the branch be merged.
+
+@item
+If you don't have commit access, create the ``Request for merging''
+issue and request that someone creates the branch.  Include a list of
+issues/patches to include on the branch.
+@end enumerate
+
+Normally branches will be merged in a ``first come, first merged''
+manner, tracked through the guix-patches issues.  If you agree on a
+different order with those involved, you can track this by updating
+which issues block@footnote{You can mark an issue as blocked by another
+by emailing @email{control@@debbugs.gnu.org} with the following line in
+the body of the email: @code{block XXXXX by YYYYY}.  Where @code{XXXXX}
+is the number for the blocked issue, and @code{YYYYY} is the number for
+the issue blocking it.} which other issues.  Therefore, to know which
+branch is at the front of the queue, look for the oldest issue, or the
+issue that isn't @dfn{blocked} by any other branch merges.  An ordered
+list of branches with the open issues is available at
+@url{https://qa.guix.gnu.org}.
 
 Once a branch is at the front of the queue, wait until sufficient time
 has passed for the build farms to have processed the changes, and for
@@ -2329,6 +2360,9 @@ Managing Patches and Branches
 @indicateurl{https://qa.guix.gnu.org/branch/@var{branch}} to see
 information on some builds and substitute availability.
 
+Once the branch has been merged, the issue should be closed and the
+branch deleted.
+
 @node Debbugs User Interfaces
 @subsection Debbugs User Interfaces
 

base-commit: 2bea3f256209c4f92a2ace28b45d1f452a2b51ba
-- 
2.41.0





Information forwarded to pelzflorian@HIDDEN, ludo@HIDDEN, guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 1 May 2024 17:08:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 01 13:08:15 2024
Received: from localhost ([127.0.0.1]:38437 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s2DRH-0004Gd-09
	for submit <at> debbugs.gnu.org; Wed, 01 May 2024 13:08:15 -0400
Received: from mira.cbaines.net
 ([2a01:7e00:e000:2f8:fd4d:b5c7:13fb:3d27]:58751)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1s2DRF-0004GX-Tu
 for 70549 <at> debbugs.gnu.org; Wed, 01 May 2024 13:08:14 -0400
Received: from localhost (unknown [212.132.255.10])
 by mira.cbaines.net (Postfix) with ESMTPSA id CE70227BBE2;
 Wed,  1 May 2024 18:07:49 +0100 (BST)
Received: from felis (localhost.lan [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id c20c704d;
 Wed, 1 May 2024 17:07:49 +0000 (UTC)
From: Christopher Baines <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#70549] [PATCH] doc: Make changes to the handling of branches.
In-Reply-To: <874jbh5wra.fsf@HIDDEN> ("Ludovic =?utf-8?Q?Court=C3=A8s=22'?=
 =?utf-8?Q?s?= message of "Wed, 01 May 2024 18:20:57 +0200")
References: <94192a7b7eb8d2dc5008c20abcc3940b4474d800.1713964129.git.mail@HIDDEN>
 <874jbh5wra.fsf@HIDDEN>
User-Agent: mu4e 1.12.2; emacs 29.3
Date: Wed, 01 May 2024 18:07:46 +0100
Message-ID: <87jzkdv4t9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 70549
Cc: 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

>>  To help coordinate the merging of branches, you must create a new
>> -guix-patches issue each time you wish to merge a branch (@pxref{The
>> -Issue Tracker}).  The title of the issue requesting to merge a branch
>> -should have the following format:
>> +guix-patches issue each time you create a branch (@pxref{The Issue
>> +Tracker}).  The title of the issue requesting to merge a branch should
>> +have the following format:
>
> This means someone on the team with commit access explicitly commits the
> branch at the time they send the merge request email, right?

There's intentionally no mention of teams here, but that's pretty much
it. I'm not intending this to be super strict, like forgetting the issue
then creating it a day or two later is fine.

You mention commit access, and that does make me think that maybe we
should include something saying that if you don't have commit access,
please go ahead and create the issue, and in it ask for the branch to be
created. With the expectation that they'll be someone with commit access
to help with creating and managing the branch.

>> +@item
>> +The commits on the branch should be a combination of the patches
>> +relevant to the branch.
>
> Perhaps add: =E2=80=9C; patches not related to the topic of the branch sh=
ould go
> elsewhere.=E2=80=9D

Good idea.

>> +@item
>> +Avoid merging master in to the branch.  Prefer rebasing or re-creating
>> +the branch on top of an updated master revision.
>> +
>> +@item
>> +Minimise the changes on master that are missing on the branch prior to
>> +merging the branch in to master.  Merging master in to the branch can be
>> +appropriate for this purpose.
>
> s/in to/into/

Good spot.

Thanks,

Chris

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmYyduNfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XdCtQ/9F2NLJJai6GbdHNb4fqlZvFnKi6bsGTEy
NI9BpFXEUe1Plp7rds3ZLCsW+itLvoFNJpengmrySsj/tPum/gWlEPwLyY/omtz3
05NZW0Xt16Ij0pHnKA/o5Xt8oZgBAEzsg33pgS8/uBFZcmFWebMFGvd/znTev2Xo
MJPlnrb0pgS+9noqB8DRcYaEe3uea5PLiS+JyEqOkzBNfp78JwJV5pbyYt6HEFOJ
1dKfiPUTLywIqjN6xhEDfuPNYUr91CJRXYHVBAK3fvuRCjlYfNo0l/PXk4cz5p0X
QshhDIgEwZ6vJImQgouzmkBqUKxmlOngiF3BLSfKG8m6JoB27oUMGAvzLVa21tNZ
2vtBI2zCdzJHn/XB9wKXhOfS082zrp4nmeHYCkMqu/yXWNDSLk3+BcSxJC6XvfW9
UGJPEQk5HE0OJLJko9uh+LNB60Y/G77iXDcfeNHw30gYJa+ssyWtmNOUf/FXjtzS
S7U4Am1dCRlpp8/5SzIcwIOduNdQQnUF2phdmX7q44ya7WtMwkGpbzJt1yqyZOD0
6mNemQuJNQD/EXRKTqECoYIhTIhynQqyuLfUOD9ROWeHw0TPDNr2aYLXy/ovoPa/
GxlpE7ZC34WSE5j48SjtBIdE2nQNqR7ZwKjYu1gPExzXBMoky+WQX7Z8WNTn2kFB
6/ixkKhkUUM=
=nkZH
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 1 May 2024 16:21:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 01 12:21:29 2024
Received: from localhost ([127.0.0.1]:38214 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s2Ci1-0003Nv-6B
	for submit <at> debbugs.gnu.org; Wed, 01 May 2024 12:21:29 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:47938)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1s2Chz-0003NX-9C
 for 70549 <at> debbugs.gnu.org; Wed, 01 May 2024 12:21:27 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1s2ChY-0006xr-GE; Wed, 01 May 2024 12:21:00 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:Date:References:In-Reply-To:Subject:To:
 From; bh=xiObmoUniC4E/ixABwDaHpNJxHaO+YwaMsn8kASCgZw=; b=sebl+mtA5k4YJQRB7LFg
 60n8mbsYSsd0V8RFTCAdb+D0D7TQHGKWL3PKrZtAMPN4QqMcjfrcbJGFCVhqhdjzJxvpMDUARem2C
 PpHhTLlefr77pi17+5YXN9HsVYRIKlLNcV9mZnUi3vcF+9yXehR8ubWmz/og4uJdB3ahW26SL6CpO
 SBQteSxyA1Ij9SlSUVfZZFrCIzGb+4f5qo3BJ9WtrB1gDnE3XUHPdFC6orGAqmb4qiUBequOgH3Uv
 rXXa8W05ZXRELkuzDupC0OyYzqA8iH1Cf+R239gc8VKxjoIC0R/7YTJ9bLJiocBMq3p+MmDveIuLK
 A8Xlj+Yb2Ok/RQ==;
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: [bug#70549] [PATCH] doc: Make changes to the handling of branches.
In-Reply-To: <94192a7b7eb8d2dc5008c20abcc3940b4474d800.1713964129.git.mail@HIDDEN>
 (Christopher Baines's message of "Wed, 24 Apr 2024 14:08:49 +0100")
References: <94192a7b7eb8d2dc5008c20abcc3940b4474d800.1713964129.git.mail@HIDDEN>
Date: Wed, 01 May 2024 18:20:57 +0200
Message-ID: <874jbh5wra.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 70549
Cc: 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Christopher Baines <mail@HIDDEN> skribis:

> Require that you create a "Request to merge" issue when you create a bran=
ch,
> rather than when you wish to merge it.  This should help avoid this step =
being
> missed.

Excellent, I fully support this change!

A couple of questions/comments:

> Also, add information on how to manage these branches:
>
>  1. Suggest creating the branch from patches, rather than having a statef=
ul
>  branch, since this should help to reduce complexity and avoid merges.

[...]

>  To help coordinate the merging of branches, you must create a new
> -guix-patches issue each time you wish to merge a branch (@pxref{The
> -Issue Tracker}).  The title of the issue requesting to merge a branch
> -should have the following format:
> +guix-patches issue each time you create a branch (@pxref{The Issue
> +Tracker}).  The title of the issue requesting to merge a branch should
> +have the following format:

This means someone on the team with commit access explicitly commits the
branch at the time they send the merge request email, right?

> +@item
> +The commits on the branch should be a combination of the patches
> +relevant to the branch.

Perhaps add: =E2=80=9C; patches not related to the topic of the branch shou=
ld go
elsewhere.=E2=80=9D

> +@item
> +Avoid merging master in to the branch.  Prefer rebasing or re-creating
> +the branch on top of an updated master revision.
> +
> +@item
> +Minimise the changes on master that are missing on the branch prior to
> +merging the branch in to master.  Merging master in to the branch can be
> +appropriate for this purpose.

s/in to/into/

Thank you!

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 29 Apr 2024 14:42:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 10:42:43 2024
Received: from localhost ([127.0.0.1]:57615 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s1SDL-0003bT-G3
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2024 10:42:43 -0400
Received: from mira.cbaines.net ([212.71.252.8]:43404)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1s1SDJ-0003bN-FL
 for 70549 <at> debbugs.gnu.org; Mon, 29 Apr 2024 10:42:42 -0400
Received: from localhost (unknown [212.132.255.10])
 by mira.cbaines.net (Postfix) with ESMTPSA id CD32327BBE2;
 Mon, 29 Apr 2024 15:42:20 +0100 (BST)
Received: from felis (localhost.lan [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 406bd57d;
 Mon, 29 Apr 2024 14:42:20 +0000 (UTC)
From: Christopher Baines <mail@HIDDEN>
To: Andreas Enge <andreas@HIDDEN>
Subject: Re: Managing patches and branches, retrospective and futher changes?
In-Reply-To: <Zi-ff4xC0teYgXsf@jurong> (Andreas Enge's message of "Mon, 29 Apr
 2024 15:24:15 +0200")
References: <87o79yvqtn.fsf@HIDDEN> <Zi-ff4xC0teYgXsf@jurong>
User-Agent: mu4e 1.12.2; emacs 29.3
Date: Mon, 29 Apr 2024 15:42:18 +0100
Message-ID: <87a5lcz0vp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 70549
Cc: guix-devel@HIDDEN, 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Andreas Enge <andreas@HIDDEN> writes:

> Hello,
>
> Am Wed, Apr 24, 2024 at 02:21:56PM +0100 schrieb Christopher Baines:
>> Let me know if you have any thoughts or questions!
>
> in this part:
> +@item
> +Minimise the changes on master that are missing on the branch prior to
> +merging the branch in to master.  Merging master in to the branch can be
> +appropriate for this purpose.
>
> I would drop the second sentence. It mildly contradicts the previous
> "avoid merging master into the branch". Writing "avoid merging" instead
> of "never merge" already allows for some leeway, I would prefer not to
> insist on it.

Yeah, maybe it's redundant. I think what I was trying to say is that
minimising the changes against master is a priority, so do this even if
you resort to merging master in to the branch.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmYvscpfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XdsoQ/9GePG2du8EvHLSiEZs0Z0jV18C0rRcxsZ
U9yDOqrNs16kAiroF+/p6EMQ2vaSWmCKS5JeHGyunrmlybSWA98I2bRF97V986XY
kO6BMyRFSpkr7B6y8gM943PJt5i7DtBk3T+Z/OCwagSP9nfp0rwfQIlIaL6DRHe/
tv99bgBpPscExoEKcwqGKqEG/Bp0YddXqbszpTRIi0qA+jDAvkDA0QQnyfviirXp
NoAFZtIyFBXh2+c+PNbjxJn8UCoWpV3WpMSrPKai02zulu86wIYG0q5V4UGG26ox
Ow8uXvkl0Nao1enDcBog6ILMpk9vl+9qjdnalGlS+r2RK4W9P0M0gjWh6N4Yrkjq
xhHnrJr8oQZ8kgkopJT4A2G6Ai2zo86KJcgK9BIwRAnGMcCxjOUu0fjst0WB9VCJ
gbIOGJtlO7WuHCx+YQIHQx5dvYYtqqIG1Iv+cBkv8UxIZtFaN6wcRF1Lremrg6s1
G/yjX6ljiiCQUqpKjfAETvQ26TUcQFdUQtq4VO9Wib5p4sUjsWDx+DJB9ymHDIgE
48nIuwf7WrqunwEYO028wzUrk24FOyyQZZLIvMpxzc7XR1E8xnmm0nrZZhYV1Zz1
uIb+K532iePkdS2S4tr5r57pOAIgDmZ32I+sGdtNcyUEYGspDymOAbhD4OuNe1Kz
qXCgIAuP/VM=
=2IS/
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 29 Apr 2024 13:24:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 09:24:48 2024
Received: from localhost ([127.0.0.1]:57255 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s1Qzw-0002WY-1E
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2024 09:24:48 -0400
Received: from hera.aquilenet.fr ([185.233.100.1]:56342)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andreas@HIDDEN>) id 1s1Qzr-0002WS-Fz
 for 70549 <at> debbugs.gnu.org; Mon, 29 Apr 2024 09:24:47 -0400
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id B672D14BA;
 Mon, 29 Apr 2024 15:24:17 +0200 (CEST)
X-Virus-Scanned: Debian amavisd-new at hera.aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id AB-0e47d-wEY; Mon, 29 Apr 2024 15:24:17 +0200 (CEST)
Received: from jurong (unknown [IPv6:2001:861:c4:f2f0::c64])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 2320E482;
 Mon, 29 Apr 2024 15:24:17 +0200 (CEST)
Date: Mon, 29 Apr 2024 15:24:15 +0200
From: Andreas Enge <andreas@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: Managing patches and branches, retrospective and futher changes?
Message-ID: <Zi-ff4xC0teYgXsf@jurong>
References: <87o79yvqtn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87o79yvqtn.fsf@HIDDEN>
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 70549
Cc: guix-devel@HIDDEN, 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello,

Am Wed, Apr 24, 2024 at 02:21:56PM +0100 schrieb Christopher Baines:
> Let me know if you have any thoughts or questions!

in this part:
+@item
+Minimise the changes on master that are missing on the branch prior to
+merging the branch in to master.  Merging master in to the branch can be
+appropriate for this purpose.

I would drop the second sentence. It mildly contradicts the previous
"avoid merging master into the branch". Writing "avoid merging" instead
of "never merge" already allows for some leeway, I would prefer not to
insist on it.

Andreas





Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 26 Apr 2024 16:04:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 26 12:04:32 2024
Received: from localhost ([127.0.0.1]:38249 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s0O3l-0006yZ-37
	for submit <at> debbugs.gnu.org; Fri, 26 Apr 2024 12:04:32 -0400
Received: from mail-qk1-x72c.google.com ([2607:f8b0:4864:20::72c]:51669)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <efraim.flashner@HIDDEN>) id 1s0O3f-0006w8-Vu
 for 70549 <at> debbugs.gnu.org; Fri, 26 Apr 2024 12:04:22 -0400
Received: by mail-qk1-x72c.google.com with SMTP id
 af79cd13be357-78efd1a0022so160411085a.3
 for <70549 <at> debbugs.gnu.org>; Fri, 26 Apr 2024 09:04:01 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20230601; t=1714147436; x=1714752236; darn=debbugs.gnu.org;
 h=in-reply-to:content-disposition:mime-version:references
 :mail-followup-to:message-id:subject:cc:to:from:date:sender:from:to
 :cc:subject:date:message-id:reply-to;
 bh=tTIC2yivNjurVba1/8ocmIpuYHHfLSKbL12j1NcZuV4=;
 b=DPHeIeXYHVT0+2M2UVFGca4gfC3a/jjieaaCQjt4xiubkVHlvVT9A5+1Mmi71tv+p8
 X6VrOV0bew1UD4zzlFgpECePS5wUIdohGTgPWne+LXLPXFaNGa2zUmLijnPV+4zstbEY
 576eFY0dqHc7visLd4hH6ujdUVua9dzqU6p54xw78ObXhnW19WMcPVspKKNCi/ZzH7l4
 ZZSgEaQNOc5qxsfUh8vCtK5Vux6E7qTI7Zo85/rVb8pTanq52hExBAqacKs/nd2+jV/0
 n1fn+DWNJ6jX9igN/6OTJVvz6fb9gAlF1q9egv8h/3xDyndH6yXwHRvUrNTCs7XzLv3E
 Kjyg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20230601; t=1714147436; x=1714752236;
 h=in-reply-to:content-disposition:mime-version:references
 :mail-followup-to:message-id:subject:cc:to:from:date:sender
 :x-gm-message-state:from:to:cc:subject:date:message-id:reply-to;
 bh=tTIC2yivNjurVba1/8ocmIpuYHHfLSKbL12j1NcZuV4=;
 b=YOcCvsXraF1oFNFT587aW+CBAHAWtYfxSHFH7cilARSTMOq70y29mTnLcnaf3W4aa1
 qcGTo09xThn+7CjoVAzUzZt1Ilb3R/sFHyXMd4OFI5/0nEpvC/Q0P4c8OSHjkjVc5mjM
 XS/ogpNjxPn2CsTuLk0kNX7kxkuf3YZ5MNA3H5gnNLyIKhSZmn8R6a94KvcqwvJWCZ4o
 Pat3sgnt+BtasDz5BGhEuQmNs7QXo/MFshllacAoluw2lLSY3FhrFgmYduk6rUr7Ynku
 ioI3j8Zgc0+Wc8F/hMickg6drgLQSN2eVCNFcpR6ZoU/W1Qhiel6Joit/IQZbAQx44c1
 tDrg==
X-Forwarded-Encrypted: i=1;
 AJvYcCXebWQCabmqnsBmDqenAzWhgxE7MYOmWbC3jVM2QtE0f/ocMTq9uQgGuAamq7zCsDD4kQJmKBJNX8fTpKvBbauzx2FWiMI=
X-Gm-Message-State: AOJu0YyX3e8ia7xl0WSX5ddvCzo5gLTgN4MtkLsnW1fSuz0AyzPoEF8Z
 IKLu24fD2lq4+CYOYB9/NZu3FQrYIkcTYoEXo8FMvdvx5EG3I2by
X-Google-Smtp-Source: AGHT+IE9SENxYoSJml0Z/44he2ZCeMhftFIjL0JAjq9082n9XUNOwbGjHOOiw/cGlOtu92MRYInHww==
X-Received: by 2002:ae9:f00d:0:b0:78d:6e96:937a with SMTP id
 l13-20020ae9f00d000000b0078d6e96937amr3552991qkg.70.1714147435679; 
 Fri, 26 Apr 2024 09:03:55 -0700 (PDT)
Received: from localhost (ool-ad039216.dyn.optonline.net. [173.3.146.22])
 by smtp.gmail.com with ESMTPSA id
 c5-20020a05620a11a500b007907a91e573sm4172978qkk.130.2024.04.26.09.03.54
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 26 Apr 2024 09:03:55 -0700 (PDT)
Date: Fri, 26 Apr 2024 19:03:56 +0300
From: Efraim Flashner <efraim@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: Managing patches and branches, retrospective and futher changes?
Message-ID: <ZivQbNjJvVKtGAzE@pbp>
Mail-Followup-To: Christopher Baines <mail@HIDDEN>, guix-devel@HIDDEN,
 70549 <at> debbugs.gnu.org
References: <87o79yvqtn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature"; boundary="QEUfkmCGsc2QTYCk"
Content-Disposition: inline
In-Reply-To: <87o79yvqtn.fsf@HIDDEN>
X-PGP-Key-ID: 0x41AAE7DCCA3D8351
X-PGP-Key: https://flashner.co.il/~efraim/efraim_flashner.asc
X-PGP-Fingerprint: A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 70549
Cc: guix-devel@HIDDEN, 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)


--QEUfkmCGsc2QTYCk
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

On Wed, Apr 24, 2024 at 02:21:56PM +0100, Christopher Baines wrote:
> Hey!
>=20
> Almost a year ago, the branching strategy was changed [1][2].
>=20
> 1: https://issues.guix.gnu.org/63459
> 2: https://lists.gnu.org/archive/html/guix-devel/2023-06/msg00024.html
>=20
> I think these changes have gone OK, we've had ~27 [3] branches merged in
> this manor and I think looking back these changes have been
> helpful. Coordination and visibility has improved, and we've been able
> to build and test more prior to merging.

I'd like to just say that this (without checking the numbers) is almost
10x the number of merges we had previously with just the
core-updates/staging branch strategy.

> 3: https://issues.guix.gnu.org/search?query=3D%22Request+for+merging%22
>=20
> There's still room for more improvement though. The current guidance is
> here [4], and I've sent a patch for improvements here [5].
>=20
> 4: https://guix.gnu.org/en/manual/devel/en/html_node/Managing-Patches-and=
-Branches.html
> 5: https://issues.guix.gnu.org/70549
>=20
> Let me know if you have any thoughts or questions!
>=20
> Thanks,
>=20
> Chris



--=20
Efraim Flashner   <efraim@HIDDEN>   =D7=A8=D7=A0=D7=A9=D7=9C=D7=A4 =
=D7=9D=D7=99=D7=A8=D7=A4=D7=90
GPG key =3D A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted

--QEUfkmCGsc2QTYCk
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAABCAAdFiEEoov0DD5VE3JmLRT3Qarn3Mo9g1EFAmYr0GsACgkQQarn3Mo9
g1EEwg/9GFu+h7vylBRFLjdddWZR713wRSsc1BN6V/9FMMUCnVjCXCX4hTcvbqcF
RbUhwP3O31Ui3JyJOTOA51KwNCracsHrUJJjgVxaVNs8VBKCqayxOjQdwoLBqnPu
EyETqadg1ZPltYLDE/bHad27ZaKeG69gTtPFW7bgiUycSL8HZis8+CxHFTbcT7cU
bOGxHF5Q+VVzYlSz5mDoDm0V7hE4gb93zD3eCBCptLEX9OWoP5a14WnHEF08vy/t
659PZdbndVA6wygtr94xPbaJE7oIfHOvsCGwvmdbYl/JyrHnaXk2i9A6S+6Whr7g
5A1LQDZqIrmHrn+9BT0c4mT4D8mD/ePyzDs2dtShKj9/sMpitz2JqIigP+JPya+d
enVwmx3myHWu79e6i35Rmoh1yl6UQo5jsSF7ViHHStwVRxDE18JGXLcbde2qnbcd
6wt8F8SwXonZge+zqd8WJuicgIWbg/5gdqmVxztIQ++N/UyY5JKZBOEEgFeJmfo1
juN69Uu5KDQgsTMT7d21IBa+JmJqx7SipSvKX4kf0XTHcNOLT7DLVdZTsInPuvoW
qsn/Nqn4v/0OdTyyaTedXQsI419QDLMqi4L+stPed5k+MtM0yN0weDaMTb2P2pg4
t93HFCPgMahQQr3eeXEJ74r33nOIZFZZeoHu0GnVkPPOywE34ag=
=pXQy
-----END PGP SIGNATURE-----

--QEUfkmCGsc2QTYCk--




Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 25 Apr 2024 18:29:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 25 14:29:17 2024
Received: from localhost ([127.0.0.1]:33252 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1s03qL-0001AH-Bc
	for submit <at> debbugs.gnu.org; Thu, 25 Apr 2024 14:29:16 -0400
Received: from mira.cbaines.net
 ([2a01:7e00:e000:2f8:fd4d:b5c7:13fb:3d27]:53181)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1s03qD-00017f-Cr
 for 70549 <at> debbugs.gnu.org; Thu, 25 Apr 2024 14:29:09 -0400
Received: from localhost (unknown [212.132.255.10])
 by mira.cbaines.net (Postfix) with ESMTPSA id 20EC427BBE2;
 Thu, 25 Apr 2024 19:28:45 +0100 (BST)
Received: from felis (localhost.lan [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 29fdf516;
 Thu, 25 Apr 2024 18:28:43 +0000 (UTC)
From: Christopher Baines <mail@HIDDEN>
To: Steve George <steve@HIDDEN>
Subject: Re: Managing patches and branches, retrospective and futher changes?
In-Reply-To: <tunyb6mbzarwk4nvliv6ruqumftkyaprgsa37ndpjkb3e4ct26@iat5utrstgrl>
 (Steve George's message of "Thu, 25 Apr 2024 08:29:20 +0100")
References: <87o79yvqtn.fsf@HIDDEN>
 <tunyb6mbzarwk4nvliv6ruqumftkyaprgsa37ndpjkb3e4ct26@iat5utrstgrl>
User-Agent: mu4e 1.12.2; emacs 29.3
Date: Thu, 25 Apr 2024 19:28:41 +0100
Message-ID: <87il05uwiu.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 70549
Cc: guix-devel@HIDDEN, 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Steve George <steve@HIDDEN> writes:

> I think we should strongly recommend against long-running unmerged branches.
>
> Perhaps there could be a recommendation to merge every 3 months.

My hope is that with these process changes, we won't end up with
long-running branches.

Maybe we could add a recommendation, but I'm not really sure if that
would help. We still want to merge these changes when they and related
things are ready, so it's not really something that can be willed or
commanded to happen.

> Could we add any automation to remind people if:
>
> 1. a branch has been unmerged for more than 3 months

We can have QA highlight how long the issues have been open for, that's
quite easy to do.

> 2. an odd merge takes places (e.g. the core-updates merges)

I'm not quite sure what you mean here?

Thanks,

Chris

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmYqoNlfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XfLrw//ebu+GxC3icjTU6qSjdU12k7zfJYlW7aN
oH6iY9IWc3+6MYvRq4g8rHcFVIrdeW9f1N63+9tTNweioIMMC2wYLyssW1rx3QEk
9t7ts8RrgR7xssa3/XngyaVu9mS+3XxvEOqPonsn7Ryj1LlaHE6rgUPVVqJtrokU
mDkzQGN+5nxckIkqR3vakpQSxABUNAxPrhrj8kGm0NRbwbEF5GgxRhGPi+kavx+Y
8XdodN3z6CHsCccM56i26caaCbqtiJwUcFcQM+w48G0tKO7HLCupBNdgVMWO5cbs
izaaGriEEKFveB/7oBtucQw168gKxKJI9Q7OFK8uzPm83p2j4c/vBcd7p8qbNWb+
TMzZEi4Q/UGCvAYfi1XjKmNebB8yvMVe5/T9xsevqL3FQ6JdSek3NwnT9XAdKeKn
J/2Ilpe6ZvTluARdetq1ru11yXqv7Z4rwnYnf1VYKTXjq5U5BXfF4zDcsdWS0nSl
Yus/f80hmoZCnpMTOB4Kq2Jm21Nh7jTpNRsQ0s2gm3nEBUhXav25JR8yGAHq2+Tl
76JZa/sb+IHynePcd6lLeJsgnGHSbHgHeC74nx+ECDplDDu4Hwajhjy8ZDYpk8DC
egtxpLIOaJITnXe38rDP+jsA9KomC2JIamv9/3D+JlMlx9npUOOD7HV3QuhzqFxa
kOW0dC+wckg=
=xj0Z
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 25 Apr 2024 07:29:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 25 03:29:57 2024
Received: from localhost ([127.0.0.1]:60427 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1rztYJ-0001M5-8o
	for submit <at> debbugs.gnu.org; Thu, 25 Apr 2024 03:29:57 -0400
Received: from mailtransmit04.runbox.com ([2a0c:5a00:149::25]:39334)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <steve@HIDDEN>) id 1rztYE-0001JM-2w
 for 70549 <at> debbugs.gnu.org; Thu, 25 Apr 2024 03:29:53 -0400
Received: from mailtransmit02.runbox ([10.9.9.162] helo=aibo.runbox.com)
 by mailtransmit04.runbox.com with esmtps (TLS1.2) tls
 TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 (Exim 4.93)
 (envelope-from <steve@HIDDEN>)
 id 1rztXp-003iS5-Jc; Thu, 25 Apr 2024 09:29:25 +0200
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed;
 d=futurile.net; s=selector1; h=In-Reply-To:Content-Type:MIME-Version:
 References:Message-ID:Subject:Cc:To:From:Date;
 bh=t9/wG/ayNNoTx/23AiozWTP+tjJTXHJomVRT1J7kDxs=; b=j3k+lOOTd4PRhgfQ9U9O38s2ne
 Ge7+eDs3AfwJfYEEhGMUxXmIS4jS9sskS05iRF/2K3EHCA+56cWJWiHLJl9NZzpspqJ196jGAtB+m
 nRSJtqwgbvubKRjYUHom/vbDJ4R+85np0a5INdg3dJT7FVBpNWGsm3Pa7FDN2I9igZ9IPj3tksuZO
 mlIJug9x9SPViPexQbvVr8NYyai8SSjp9aUIBK8nDQ0E7IkxjcE/uBr0FzCzYl0z9B7a7s6DGsiqd
 bqbdmRaSHSUCmKw9Y9MirBg9SHRThnWcO4KR3SewtHwWQBWsA2Qk19uqIECS+AHhPiLhjpYDqY2w/
 EzzwXH4w==;
Received: from [10.9.9.72] (helo=submission01.runbox)
 by mailtransmit02.runbox with esmtp (Exim 4.86_2)
 (envelope-from <steve@HIDDEN>)
 id 1rztXp-0005pR-5f; Thu, 25 Apr 2024 09:29:25 +0200
Received: by submission01.runbox with esmtpsa [Authenticated ID (641962)]
 (TLS1.2:ECDHE_SECP256R1__RSA_SHA256__AES_256_GCM:256) (Exim 4.93)
 id 1rztXm-00Bwxh-ST; Thu, 25 Apr 2024 09:29:22 +0200
Date: Thu, 25 Apr 2024 08:29:20 +0100
From: Steve George <steve@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: Managing patches and branches, retrospective and futher changes?
Message-ID: <tunyb6mbzarwk4nvliv6ruqumftkyaprgsa37ndpjkb3e4ct26@iat5utrstgrl>
References: <87o79yvqtn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
In-Reply-To: <87o79yvqtn.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 70549
Cc: guix-devel@HIDDEN, 70549 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi,

I think we should strongly recommend against long-running unmerged branches.

Perhaps there could be a recommendation to merge every 3 months.

Could we add any automation to remind people if:

1. a branch has been unmerged for more than 3 months
2. an odd merge takes places (e.g. the core-updates merges)

Thanks,

Steve

On 24 Apr, Christopher Baines wrote:
> Hey!
> 
> Almost a year ago, the branching strategy was changed [1][2].
> 
> 1: https://issues.guix.gnu.org/63459
> 2: https://lists.gnu.org/archive/html/guix-devel/2023-06/msg00024.html
> 
> I think these changes have gone OK, we've had ~27 [3] branches merged in
> this manor and I think looking back these changes have been
> helpful. Coordination and visibility has improved, and we've been able
> to build and test more prior to merging.
> 
> 3: https://issues.guix.gnu.org/search?query=%22Request+for+merging%22
> 
> There's still room for more improvement though. The current guidance is
> here [4], and I've sent a patch for improvements here [5].
> 
> 4: https://guix.gnu.org/en/manual/devel/en/html_node/Managing-Patches-and-Branches.html
> 5: https://issues.guix.gnu.org/70549
> 
> Let me know if you have any thoughts or questions!
> 
> Thanks,
> 
> Chris






Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at 70549 <at> debbugs.gnu.org:


Received: (at 70549) by debbugs.gnu.org; 24 Apr 2024 13:22:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 24 09:22:20 2024
Received: from localhost ([127.0.0.1]:58442 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1rzcZo-0005Sl-8F
	for submit <at> debbugs.gnu.org; Wed, 24 Apr 2024 09:22:20 -0400
Received: from mira.cbaines.net ([212.71.252.8]:43386)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1rzcZl-0005Sd-Gf
 for 70549 <at> debbugs.gnu.org; Wed, 24 Apr 2024 09:22:19 -0400
Received: from localhost (unknown [212.132.255.10])
 by mira.cbaines.net (Postfix) with ESMTPSA id 3223527BBE2;
 Wed, 24 Apr 2024 14:21:59 +0100 (BST)
Received: from felis (localhost.lan [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 6575fcf6;
 Wed, 24 Apr 2024 13:21:58 +0000 (UTC)
From: Christopher Baines <mail@HIDDEN>
To: guix-devel@HIDDEN, 70549 <at> debbugs.gnu.org
Subject: Managing patches and branches, retrospective and futher changes?
User-Agent: mu4e 1.12.2; emacs 29.3
Date: Wed, 24 Apr 2024 14:21:56 +0100
Message-ID: <87o79yvqtn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 70549
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Hey!

Almost a year ago, the branching strategy was changed [1][2].

1: https://issues.guix.gnu.org/63459
2: https://lists.gnu.org/archive/html/guix-devel/2023-06/msg00024.html

I think these changes have gone OK, we've had ~27 [3] branches merged in
this manor and I think looking back these changes have been
helpful. Coordination and visibility has improved, and we've been able
to build and test more prior to merging.

3: https://issues.guix.gnu.org/search?query=%22Request+for+merging%22

There's still room for more improvement though. The current guidance is
here [4], and I've sent a patch for improvements here [5].

4: https://guix.gnu.org/en/manual/devel/en/html_node/Managing-Patches-and-Branches.html
5: https://issues.guix.gnu.org/70549

Let me know if you have any thoughts or questions!

Thanks,

Chris

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmYpB3RfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XdQnA//Snz4ZWMeR3pJ8fyzclxc6tNUX1Q9gZGU
4kZaYQT/S/XnG53cSRPJxawnwWCli9ylv3piD0Xr8ZltfPomnZv8bKLztygEyCkD
gwQnOF4oxLIcSWKG5vsrIAdhDlY4XHhj+HPa55DQSfSqKaYfwWdMy35vXUiSInOw
3B07dPCrOAqMGwGVMPjDLm238hpFE2L0jQi93vFdCrIIueeKnNwhwWVmeZTxYALA
ifMDwP3EugH8Djq6abweBIpEVY+g1915y/S4i2H8GirgqDfA+Hd1GGIFR6mr+d8e
zaAcPyupYNwy/lzHRQkCwjCy/OWg3PabDQfADV9k/z2dsEB7+RVOdu93wwy9UF07
YNsBnsHA4MHsXsyj9hpWcHEWOsjuFhHnYDYW13Zlo8YdmncyTl/NMnXmMXeTjhMM
qN5pbABSbWdHu9gExUrhTZJD60AwDfv/o4k6JkI5lYHrmrNwWRsL/lptbKRZB6NM
BnezEQik7/v8Nqldb8pxO7rVqdKK5RLl3XnktgGxW63mKaRGBxwjsQt2N/CsZ9Xh
Bs7ypyu2kAYEY97ZNmRbcmBrPDN1GdfXe9Pi6IeqQGaOHtTLmTjxzAsx7TL0+qFa
tWYZ8nGac3RaWckUQYSpW0JiguytQIEHZaUO9n30/z3xDX3nz5uTbfRCni8f0scZ
CcrOdP/RqYo=
=yr/d
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Apr 2024 13:09:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 24 09:09:26 2024
Received: from localhost ([127.0.0.1]:58386 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1rzcNI-0003Hd-Go
	for submit <at> debbugs.gnu.org; Wed, 24 Apr 2024 09:09:26 -0400
Received: from lists.gnu.org ([2001:470:142::17]:59042)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1rzcNE-0003Ff-BP
 for submit <at> debbugs.gnu.org; Wed, 24 Apr 2024 09:09:22 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mail@HIDDEN>) id 1rzcMo-0000cV-UI
 for guix-patches@HIDDEN; Wed, 24 Apr 2024 09:08:55 -0400
Received: from mira.cbaines.net ([2a01:7e00:e000:2f8:fd4d:b5c7:13fb:3d27])
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <mail@HIDDEN>) id 1rzcMm-0002Di-EH
 for guix-patches@HIDDEN; Wed, 24 Apr 2024 09:08:54 -0400
Received: from localhost (unknown [212.132.255.10])
 by mira.cbaines.net (Postfix) with ESMTPSA id 89F2627BBE2
 for <guix-patches@HIDDEN>; Wed, 24 Apr 2024 14:08:50 +0100 (BST)
Received: from localhost (localhost [local])
 by localhost (OpenSMTPD) with ESMTPA id d404e406
 for <guix-patches@HIDDEN>; Wed, 24 Apr 2024 13:08:50 +0000 (UTC)
From: Christopher Baines <mail@HIDDEN>
To: guix-patches@HIDDEN
Subject: [PATCH] doc: Make changes to the handling of branches.
Date: Wed, 24 Apr 2024 14:08:49 +0100
Message-ID: <94192a7b7eb8d2dc5008c20abcc3940b4474d800.1713964129.git.mail@HIDDEN>
X-Mailer: git-send-email 2.41.0
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
Received-SPF: pass client-ip=2a01:7e00:e000:2f8:fd4d:b5c7:13fb:3d27;
 envelope-from=mail@HIDDEN; helo=mira.cbaines.net
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001, UNPARSEABLE_RELAY=0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.9 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.1 (/)

Require that you create a "Request to merge" issue when you create a branch,
rather than when you wish to merge it.  This should help avoid this step being
missed.

Also, add information on how to manage these branches:

 1. Suggest creating the branch from patches, rather than having a stateful
 branch, since this should help to reduce complexity and avoid merges.

 2. Require that branches don't have unnecessary changes, since this increases
 the risks of conflicts with other branches.

 3. Suggest avoiding merges since these create a more complicated Git history.

 4. Suggest that the branch be up to date before merging, as this helps avoid
 the combination of master plus the branch differing significantly from the
 branch alone.

Finally, require that the branch be deleted once they're merged.  This
prepares for the branch being created again.

* doc/contributing.texi (Managing Patches and Branches): Make changes to the
handling of branches.

Change-Id: Ib9419c6df94f485475bd6f147e82ea254e76cec2
---
 doc/contributing.texi | 59 ++++++++++++++++++++++++++++++-------------
 1 file changed, 42 insertions(+), 17 deletions(-)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index ad0f5a8ecd..038ed7d040 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -2290,9 +2290,9 @@ Managing Patches and Branches
 
 @cindex feature branches, coordination
 To help coordinate the merging of branches, you must create a new
-guix-patches issue each time you wish to merge a branch (@pxref{The
-Issue Tracker}).  The title of the issue requesting to merge a branch
-should have the following format:
+guix-patches issue each time you create a branch (@pxref{The Issue
+Tracker}).  The title of the issue requesting to merge a branch should
+have the following format:
 
 @cindex merge requests, template
 @example
@@ -2300,20 +2300,42 @@ Managing Patches and Branches
 @end example
 
 The @url{https://qa.guix.gnu.org/, QA infrastructure} recognizes such
-issues and lists the merge requests on its main page.  Normally branches
-will be merged in a ``first come, first merged'' manner, tracked through
-the guix-patches issues.
-
-If you agree on a different order with those involved, you can track
-this by updating which issues block@footnote{You can mark an issue as
-blocked by another by emailing @email{control@@debbugs.gnu.org} with the
-following line in the body of the email: @code{block XXXXX by YYYYY}.
-Where @code{XXXXX} is the number for the blocked issue, and @code{YYYYY}
-is the number for the issue blocking it.} which other issues.
-Therefore, to know which branch is at the front of the queue, look for
-the oldest issue, or the issue that isn't @dfn{blocked} by any other
-branch merges.  An ordered list of branches with the open issues is
-available at @url{https://qa.guix.gnu.org}.
+issues and lists the merge requests on its main page.  The following
+points apply to managing these branches:
+
+@enumerate
+@item
+The commits on the branch should be a combination of the patches
+relevant to the branch.  It should be possible to re-create the branch
+by starting from master and applying the relevant patches.
+
+@item
+Any changes that can be made on the master branch, should be made on the
+master branch.  If a commit can be split to apply part of the changes on
+master, this is good to do.
+
+@item
+Avoid merging master in to the branch.  Prefer rebasing or re-creating
+the branch on top of an updated master revision.
+
+@item
+Minimise the changes on master that are missing on the branch prior to
+merging the branch in to master.  Merging master in to the branch can be
+appropriate for this purpose.
+@end enumerate
+
+Normally branches will be merged in a ``first come, first merged''
+manner, tracked through the guix-patches issues.  If you agree on a
+different order with those involved, you can track this by updating
+which issues block@footnote{You can mark an issue as blocked by another
+by emailing @email{control@@debbugs.gnu.org} with the following line in
+the body of the email: @code{block XXXXX by YYYYY}.  Where @code{XXXXX}
+is the number for the blocked issue, and @code{YYYYY} is the number for
+the issue blocking it.} which other issues.  Therefore, to know which
+branch is at the front of the queue, look for the oldest issue, or the
+issue that isn't @dfn{blocked} by any other branch merges.  An ordered
+list of branches with the open issues is available at
+@url{https://qa.guix.gnu.org}.
 
 Once a branch is at the front of the queue, wait until sufficient time
 has passed for the build farms to have processed the changes, and for
@@ -2321,6 +2343,9 @@ Managing Patches and Branches
 @indicateurl{https://qa.guix.gnu.org/branch/@var{branch}} to see
 information on some builds and substitute availability.
 
+Once the branch has been merged, the issue should be closed and the
+branch deleted.
+
 @node Debbugs User Interfaces
 @subsection Debbugs User Interfaces
 

base-commit: e2ba93373a29ddf5d5754368957e89f3b426bb0a
-- 
2.41.0





Acknowledgement sent to Christopher Baines <mail@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#70549; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 8 May 2024 11:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.